﻿------------------------------------------------------------------------------------------
--Holy Power------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, LSM, _ = unpack(select(2,...))

local BORDER = 2
local CLASSBAR_WIDTH = 269 - (BORDER*2)
local SPELL_POWER_HOLY_POWER = SPELL_POWER_HOLY_POWER
local MAX_HOLY_POWER = 5
local width = 250 / 5
local UnitPower = UnitPower

function SN:HPower(frame)
	--local m = SNmedia
	local SNd = SN.data.profile
	local color = LSM.classResources.PALADIN

	local holypower = CreateFrame("Frame", nil, frame)
	holypower:SetSize(CLASSBAR_WIDTH, 16)
	holypower:SetPoint("CENTER", frame, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(holypower)
	else
		holypower:SetBackdrop({
		bgFile = LSM.media.blankTex, 
		edgeFile = LSM.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 4, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		holypower:SetBackdropColor(0.1, 0.1, 0.1, 0.3)
		holypower:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, MAX_HOLY_POWER do
		holypower[i] = CreateFrame("StatusBar", nil, holypower)
		holypower[i]:SetSize((holypower:GetWidth() - 16) / MAX_HOLY_POWER, holypower:GetHeight())
		if i == 1 then
			holypower[i]:SetPoint("LEFT", holypower)
		else
			holypower[i]:SetPoint("LEFT", holypower[(i - 1)], "RIGHT", 4, 0)
		end
		holypower[i]:SetStatusBarTexture(LSM.media.minTex)
		holypower[i]:GetStatusBarTexture():SetHorizTile(false)
		holypower[i]:SetMinMaxValues(0, 1)
		holypower[i]:SetStatusBarColor(unpack(color))
	end
	
	return holypower
end

function SN:SetupHoly()
	if select(2, UnitClass("player")) ~= "PALADIN" then return end
	local SNd = SN.data.profile
	local frame = F.classpower

	frame.holypower = SN:HPower(frame)
	F.classpower.frame = frame.holypower
	frame.holypower:RegisterEvent("UNIT_POWER")
	frame.holypower:SetScript("OnEvent", function(self, event, ...)

		if event == "UNIT_POWER" then
			local unitID, type = ...
			if unitID == "player" and type == "HOLY_POWER" then
				local hpower = UnitPower("player", SPELL_POWER_HOLY_POWER)
				if hpower > 0 then
					for i = 1, MAX_HOLY_POWER do
						self[i]:SetValue(0)
					end
					for i = 1, hpower do
						self[i]:SetValue(1)
					end
				else
					for i = 1, MAX_HOLY_POWER do
						self[i]:SetValue(0)
					end
				end
			end
		end
	end)
	local hpower = UnitPower("player", SPELL_POWER_HOLY_POWER)
	if hpower > 0 then
		for i = 1, hpower do
			frame.holypower[i]:SetValue(1)
		end
	else
		for i = 1, MAX_HOLY_POWER do
			frame.holypower[i]:SetValue(0)
		end
	end
	--if SNd.classResources.enable == false then
	--	SN:HolyDisable()
	--end
end

function SN:HolyEnable()
	local frame = F.classpower
	frame.holypower:Show()
	frame.holypower:RegisterEvent("UNIT_POWER")
end

function SN:HolyDisable()
	local frame = F.classpower
	frame.holypower:UnregisterEvent("UNIT_POWER")
	frame.holypower:Hide()
	collectgarbage("collect")
end