﻿------------------------------------------------------------------------------------------
--Death Knight Runes----------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, LSM, _ = unpack(select(2,...))

local BORDER = 2
local CLASSBAR_WIDTH = 269 - (BORDER*2)
local runemap = { 1, 2, 5, 6, 3, 4 }
local GetRuneCooldown = GetRuneCooldown
local GetSpecialization = GetSpecialization
local GetRuneType = GetRuneType

function SN:DKRunes(frame)
	--local m = SNmedia
	local SNd = SN.data.profile
	local color = LSM.classResources.DEATHKNIGHT
	
	local runes = CreateFrame("Frame", nil, frame)
	runes:SetSize(CLASSBAR_WIDTH, 16)
	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(runes)
	else
		runes:SetBackdrop({
		bgFile = LSM.media.blankTex, 
		edgeFile = LSM.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 4, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		runes:SetBackdropColor(0.1, 0.1, 0.1, 0.3)
		runes:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	runes:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
	for i = 1, 6 do
		runes[i] = CreateFrame("StatusBar", nil, runes)
		runes[i]:SetSize((runes:GetWidth() - 15) / 6, runes:GetHeight())
		local offset
		if i == 1 then
			runes[i]:SetPoint("LEFT", runes)
		else
			runes[i]:SetPoint("LEFT", runes[(i - 1)], "RIGHT", 3, 0)
		end
		runes[i]:SetStatusBarTexture(LSM.media.minTex)
		runes[i]:GetStatusBarTexture():SetHorizTile(false)
	end
	
	return runes
end

function SN:SetupRunes()
	if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then return end
	local SNd = SN.data.profile
	local frame = F.classpower
	frame.runes = SN:DKRunes(frame)
	F.classpower.frame = frame.runes

	frame.runes:RegisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:RegisterEvent("RUNE_POWER_UPDATE")
	frame.runes:SetScript('OnUpdate', function(self, elapsed)
		if GetSpecialization() == nil and elapsed then return end
		local runes = self:GetParent()
		if(runes) then
			for i=1, 6 do
				SN:UpdateType(self, nil, i)
			end
		end
		self:SetScript('OnUpdate', nil)
	end)
	frame.runes:SetScript("OnEvent", function(self, event, ...)
		if event == "RUNE_POWER_UPDATE" then
			local rid = ...
			SN:UpdateRune(self, event, rid, true)
		elseif event == "RUNE_TYPE_UPDATE" then
			local rid = ...
			SN:UpdateType(self, event, rid, true)
		end
		--SN:EventHandler(self, event, ...)
	end)
	if not SNd.classResources.enable then
		SN:RuneDisable()
	end
end

function SN:UpdateType(self, event, rid)
	local SNd = SN.data.profile
	local runeColors = LSM.classResources.DEATHKNIGHT
	local rune = self[runemap[rid]]
	if not GetRuneType(rid) and not alt then return; end
	local colors = runeColors[GetRuneType(rid) or alt]
	--local r, g, b = colors[1], colors[2], colors[3]

	rune:SetStatusBarColor(unpack(colors))
end

function Update(self, event)
	for i=1, 6 do
		SN:UpdateRune(self, event, i)
	end
end

function UpdateAllRuneTypes(self, elapsed)
	if GetSpecialization() == nil and elapsed then return end
	local runes = self:GetParent()
	if(runes) then
		for i=1, 6 do
			SN:UpdateType(runes, nil, i)
		end
	end
	self:SetScript('OnUpdate', nil)
end

function SN:UpdateRune(self, event, rid)
	local rune = self[runemap[rid]]
	if(rune) then
		local start, duration, runeReady = GetRuneCooldown(rid)
		if (runeReady) then
			rune:SetMinMaxValues(0, 1)
			rune:SetValue(1)
			rune:SetScript("OnUpdate", nil)
		else
			rune.duration = GetTime() - start
			rune.max = duration
			rune:SetMinMaxValues(1, duration)
			rune:SetScript("OnUpdate", function(self, elapsed)
				local duration = self.duration + elapsed
				if(duration >= self.max) then
					return self:SetScript("OnUpdate", nil)
				else
					self.duration = duration
					return self:SetValue(duration)
				end
			end)
		end
	end
end

function SN:RuneEnable()
	local frame = F.classpower
	frame.runes:Show()
	frame.runes:RegisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:RegisterEvent("RUNE_POWER_UPDATE")
end

function SN:RuneDisable()
	local frame = F.classpower
	frame.runes:UnregisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:UnregisterEvent("RUNE_POWER_UPDATE")
	frame.runes:Hide()
	collectgarbage("collect")
end